//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2012, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
/*
   
iCustom(
   string symbol,       //    (NULL- )
   int timeframe,       // - (0- )
   "KillGap",           //   
   //
   int GapPoints,       //     .; <0 -   1-  - 
   int GapHours,        //       
                           // >0 -   
                           // <0 -  
   int applied_price,   //  :
                           // 0 - PRICE_CLOSE -   
                           // 1 - PRICE_OPEN -  
                           // 2 - PRICE_HIGH - .
                           // 3 - PRICE_LOW - .
                           // 4 - PRICE_MEDIAN -  ,(high+low)/2
                           // 5 - PRICE_TYPICAL -  ,(high+low+close)/3
                           // 6 - PRICE_WEIGHTED -   ,(high+low+close+close)/4
                           // 7 - 
   //
   int mode,            // mode -   :
                           // 0-   
                           // 1-   -   
   int shift            // 
  );

==============

iCustom(NULL,0,"KillGap",GapPoints,GapHours,Price, 0,i); // 
iCustom(NULL,0,"KillGap",GapPoints,GapHours,Price, 1,i); // 
*/

#property indicator_chart_window
#property  indicator_buffers 2
//  
extern int GapPoints=33; //     .
double gp; //     
bool kg=0; // 1-  
bool ZeroBase=1; // 0 -  ;  base[]  
extern int GapHours=24; //        (>0)   (<0)
int gt; //     
extern int Price=0; //  
                    // .
double   price[],//   
base[]; //  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void init() 
  {
   if(GapPoints<0) {kg=1; GapPoints=-GapPoints; ZeroBase=0;} // 0 -  
   if(GapPoints>0) {kg=1; gp=GapPoints*Point;} //     
   if(GapHours>0) gt=GapHours*3600; else gt=-GapHours*60; //     
   SetIndexBuffer(0,price); //   
   SetIndexLabel(0,"Price "+GapPoints+"p.");
   SetIndexBuffer(1,base); //  
   SetIndexLabel(1,"Base "+GapHours+"h.");
   IndicatorDigits(5);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void start() 
  {
//  
   static datetime gtime; //  
                          //   int limit=Bars-IndicatorCounted()-1;  
//   if(limit>1) {limit=Bars-1; gtime=0;}
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   if(counted_bars==0) limit-=1+1;
//    
   for(int i=limit; i>=0; i--) 
     {
      if(kg*(gtime!=Time[i])) 
        {
         static double base_i; // ,  
         double gap=Close[i+1]-Open[i]; //    
         if((MathAbs(gap)>=gp)*(Time[i]-Time[i+1]>gt)) 
           {
            base_i+=gap; //  
            gtime=Time[i]; //  
           }
        }
      if(i==limit && i>1) base_i=0; // 
      base[i]=ZeroBase*base_i; // 
                               //  
      switch(Price) 
        {
         case 0: double p=Close[i]; break;
         case 1: p=Open[i]; break;
         case 2: p=High[i]; break;
         case 20: p=(2*High[i]+Low[i]+Close[i])/4; break; // Weighted High
         case 3: p=Low[i]; break;
         case 30: p=(High[i]+2*Low[i]+Close[i])/4; break; // Weighted Low
         case 4: p=(High[i]+Low[i])/2; break; // Middle
         case 5: p=(High[i]+Low[i]+Close[i])/3; break; // Typical
         case 6: p=(High[i]+Low[i]+2*Close[i])/4; break; // Weighted
         case 7: p=Volume[i]-base_i; break;
         default: p=Close[i];
        }
      price[i]=p+base_i; // 
     }
  }
//+------------------------------------------------------------------+
